# DkGridFilter

## Generics

<mark style="color:green;">`<T>`</mark> represents the object's shape coming from the data source.

## Properties

| Property      | Description                                                                                                                                                                                                         |
| ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `filterables` | <p>It is a <strong>read-only</strong> property that returns all the defined filterables.<br></p><p><strong>Type</strong>: </p><p><mark style="color:green;"><code>Map\<string, DkFilterable\<T>></code></mark>.</p> |

## Methods

| Method              | Description                                                                                                                                                                                                            |
| ------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `clearFilter()`     | <p>It removes all conditions from filterables.<br></p><p><strong>Params</strong>: None.</p><p><strong>Return</strong>: <mark style="color:green;"><code>void</code></mark>.</p>                                        |
| `isFilterApplied()` | <p>It evaluates if the DkGrid instance has one filter condition applied, at least.<br></p><p><strong>Params</strong>: None.</p><p><strong>Return</strong>: <mark style="color:green;"><code>boolean</code></mark>.</p> |
| `getFilteredRows()` | <p>It returns all rows that meet the filter conditions criteria.<br></p><p><strong>Params</strong>: None.</p><p><strong>Return</strong>: <mark style="color:green;"><code>DkGridDataRowEntry\<T>\[]</code></mark>.</p> |

## Events

| Event                        | Description                                                                                                                                                                                                                                                                                                                                                                             |
| ---------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `registerFilterableChange`   | <p>It emits when you define a column as <strong>filterable</strong>. Then, the DkGrid instance will add the column to the internal Map named <em><strong>filterables</strong></em>.<br></p><p><strong>Params</strong>: None.</p><p><strong>Return</strong>: <mark style="color:green;"><code>Observable\<DkFilterable\<T>></code></mark>.</p>                                           |
| `deregisterFilterableChange` | <p>It emits when you make a column <strong>not filterable</strong> when it was <strong>filterable</strong>. Then, the DkGrid instance will remove the column to the internal Map named <em><strong>filterables</strong></em>.<br></p><p><strong>Params</strong>: None.</p><p><strong>Return</strong>: <mark style="color:green;"><code>Observable\<DkFilterable\<T>></code></mark>.</p> |
| `filterChange`               | <p>It emits when the user has <strong>defined/changed</strong> a filter condition.<br></p><p><strong>Params</strong>: None.</p><p><strong>Return</strong>: <mark style="color:green;"><code>Observable\<DkFilterable\<T>></code></mark>.</p>                                                                                                                                            |
| `editionFilterChange`        | <p>It emits when the user has <strong>defined/changed</strong> an edition filter condition.<br></p><p><strong>Params</strong>: None.</p><p><strong>Return</strong>: <mark style="color:green;"><code>Observable\<DkFilterable\<T>></code></mark>.</p>                                                                                                                                   |
| `clearFilterChange`          | <p>It emits after the DkGrid instance has <strong>removed</strong> all the filter conditions.<br></p><p><strong>Params</strong>: None.</p><p><strong>Return</strong>: <mark style="color:green;"><code>Observable\<void></code></mark>.</p>                                                                                                                                             |
| `clearEditionFilterChange`   | <p>It emits after the DkGrid instance has <strong>removed</strong> all the filter conditions from the edition <em><strong>filterables</strong></em>.<br></p><p><strong>Params</strong>: None.</p><p><strong>Return</strong>: <mark style="color:green;"><code>Observable\<void></code></mark>.</p>                                                                                      |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dikesoft.com/reference/dkgrid-api/dkgridfilter.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
